module Security
  class CSRFTokenValidation < RuboCop::Cop::Cop
    MSG = 'Do not disable authenticity token validation'
    def_node_matcher :skip_before_action, '(send _ :skip_before_action _)'

    def on_send(node)
      return unless skip_before_action(node)

      _, _, parts = *node
      method = parts.node_parts
      add_offense(node, location: :selector) if found_match(method[0])
    end

    def found_match(method)
      [:verify_authenticity_token, 'verify_authenticity_token'].include?(method)
    end
  end
end
