module Security
  class CheckForVulnerableCode < RuboCop::Cop::Cop
    RESULT = {}

    def self.read_file
      gem_path = File.expand_path("#{File.dirname(__FILE__)}../../../../")

      file = File.open("#{gem_path}/vuln_db.json", "r").read.strip
      json = JSON.parse(file)
      json["vulnerabilities"]["rails"]
    end

    VULNERABILITY_LIST = read_file

    VULNERABILITY_LIST.each do |string|
      search = string["search_string"]
      info = string["info"]

      RESULT[search.to_sym] = info
      def_node_matcher search.to_sym, "(send _ :#{search} _)"
    end

    def on_send(node)
      _, method = *node
      return unless method

      if (info = RESULT[method])
        message = "Rails: Possible vulnerability found, CVE Details - #{info} "

        add_offense(node, location: :selector, message: message)
      end
    end
  end
end
